using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DEXRuleAlgorithm
{
    class DEXRuleAlgorithm
    {
        static void Main(string[] args)
        {
            try
            {
                if (args.Length < 0)
                {
                    Console.WriteLine("Usage: DEXRuleAlgorithm.exe ../dxi/Car.dxi 0 time");
                }
                else
                {
                    Stopwatch stopwatch = new Stopwatch();
                    Console.WriteLine("Complex rules from DEX-Rule algorithm");
                    DEXi.Model model = new DEXi.Model(args[0]);
                    List<DEXi.Attribute> all = model.AllAttributes;
                    int position = Convert.ToInt32(args[1]);
                    DEXi.DEXRule cr = new DEXi.DEXRule(all[position]);
                    if(args.Length > 2)
                    {
                        if (args[2].Equals("time"))
                        {
                            stopwatch.Start();
                            cr.ComplexRules();
                            stopwatch.Stop();
                            Console.WriteLine("Time elapsed: {0} ms", stopwatch.ElapsedMilliseconds);
                        }
                    }
                    else
                    {
                        cr.ComplexRules();
                    }
                    Console.WriteLine("=========================================================");
                }
            }
            catch (Exception e)
            {
                Console.WriteLine("DEXRuleAlgorithm: Exception: " + e.Message);
            }
        }
    }
}
